wreport::bulletin::Bitmap Struct Reference

Associate a Data Present Bitmap to decoded variables in a subset. More...

`#include <bitmaps.h>`

## Public Member Functions

| Bitmap (const Var &bitmap, const Subset &subset, unsigned anchor)
| Create a new bitmap.
| Bitmap (const Var &bitmap, const Subset &subset)
| Bitmap (const Bitmap &)=delete
Bitmap & | operator= (const Bitmap &)=delete
bool | eob () const
| True if there is no bitmap or if the bitmap has been iterated until the end.
unsigned | next ()
| Return the next variable offset for which the bitmap reports that data is present.
void | reuse ()
| Reset the bitmap iterator, to reuse the bitmap another time.

## Data Fields

Var | bitmap
| Bitmap being iterated.
std::vector< unsigned > | refs
| Arrays of variable indices corresponding to positions in the bitmap where data is present.
std::vector< unsigned >::const_reverse_iterator | iter
| Iterator over refs.

## Detailed Description

Associate a Data Present Bitmap to decoded variables in a subset.

## Constructor & Destructor Documentation

## Bitmap()

wreport::bulletin::Bitmap::Bitmap | ( | const Var & | bitmap,
|  | const Subset & | subset,
|  | unsigned | anchor )

Create a new bitmap.

Parameters

  bitmap | The bitmap variable
  subset | The subset to which the bitmap refers
  anchor | The index to the first element after the end of the bitmap (usually the C operator that defines or uses the bitmap)

References Bitmap(), and bitmap.

Referenced by Bitmap().

## Field Documentation

## iter

std::vector<unsigned>::const_reverse_iterator wreport::bulletin::Bitmap::iter

Iterator over refs.

Since refs is filled while going backwards over the subset, iteration is done via a reverse_iterator.

The documentation for this struct was generated from the following file:

- bitmaps.h